%
% bsim_delindivruns.m
%
% Batch simulation script for deleting files related to individual runs.  
% When a multirun file is available this saves a lot of space, though you 
% lose data for individual cells.  
%
% Last modification: 1/21/08


% Set paths
% manip_paths = [ manip_normal manip_NShypo05 manip_NShypo1 manip_NShypo15 ...
%     manip_NShypo2 manip_NShypo3 manip_NShyper05 manip_NShyper1 ...
%     manip_NShyper3 manip_NShyper5 ];
manip_paths = [ manip_Bhypo05 manip_Bhypo1 manip_Bhypo15 ...
    manip_Bhypo2 manip_Bhypo3 manip_Bhyper05 manip_Bhyper1 ...
    manip_Bhyper3 manip_Bhyper5 ];
% manip_paths = [ manip_PRhypo05 manip_PRhypo1 manip_PRhypo15 ...
%     manip_PRhypo2 manip_PRhypo3 manip_PRhyper05 manip_PRhyper1 ...
%     manip_PRhyper3 manip_PRhyper5 ];
% manip_paths = [ manip_ghypo05 manip_ghypo1 manip_ghypo15 ...
%     manip_ghypo2 manip_ghypo3 manip_ghyper05 manip_ghyper1 ...
%     manip_ghyper3 manip_ghyper5 ];
    
% Subjects range
first_subj = 2;  % For now, preserve the full individual runs for subject 1
last_subj = 3;

% Set path for new DA condition directory and make the directory.
runcoll_path = runcoll_stats;
taskset_path = taskset_TOBS1c_TOBS1crev;
% taskset_path = taskset_TOBS2c_TOBS2crev;

simphases_path = simphases_train;
% simphases_path = simphases_maint;
% simphases_path = simphases_rev;

% Go through all of the desired manipulation conditions and subjects and
% show the directories have the individual runs demolished in.
for xx = 1:size(manip_paths,2)
    manip_path = manip_paths(xx);
    for yy_mmr = first_subj:last_subj
        subj_num = yy_mmr;
        bsim_setdatapath;
        disp(path_name);
    end;
end;

% Prompt whether user wants to proceed.
proceed = input('Above are the directories subject to demolition. Proceed? (1=yes) ');
if (proceed ~= 1)
    disp('aborted');
    return;
end;

% Go through all of the desired manipulation conditions and subjects and
% delete the individual run files.
for xx = 1:size(manip_paths,2)
    manip_path = manip_paths(xx);
    for yy_mmr = first_subj:last_subj
        subj_num = yy_mmr;
        bsim_setdatapath;
        del_command = strcat(path_name,'*modl_parm*');
        delete(del_command);
        del_command = strcat(path_name,'*phys_parm*');
        delete(del_command);
        del_command = strcat(path_name,'*sim_out*');
        delete(del_command);
        del_command = strcat(path_name,'*cog_out*');
        delete(del_command);        
    end;
end;