%
% bsim_init.m
%
% Batch simulation initialization script.  Run this before you run any of
% the other bsim_X scripts.
%
% Last modification: 1/21/08


% Clear all variables and close all windows.
clear all;
close all;

% Load simulation run parameters.
load sim_run_params;

% Initialize the simulator types.
init_PISHTAR_types;

% Set base path selection types.
basepath_cdrive = 0;
basepath_fulldata = 1;
basepath_portdata = 2;

% Set path selection types.
runcoll_pilot = 0;
runcoll_exemplar = 1;
runcoll_stats = 2;

% Set task set types.
taskset_TOBS_TOBSrev = 0;
taskset_SOBS_SOBSrev = 1;
taskset_SOBS_TOBSrev_SOBS = 2;
taskset_TOBS1c_TOBS1crev = 3;
taskset_TOBS2c_TOBS2crev = 4;

% Set sim phases types.
simphases_train = 0;
simphases_maint = 1;
simphases_rev = 2;

% Set manipulation types.
manip_normal = 0;
manip_NShypo05 = 1;
manip_NShypo1 = 2;
manip_NShypo15 = 3;
manip_NShypo2 = 4;
manip_NShypo3 = 5;
manip_Bhypo05 = 6;
manip_Bhypo1 = 7;
manip_Bhypo15 = 8;
manip_Bhypo2 = 9;
manip_Bhypo3 = 10;
manip_PRhypo05 = 11;
manip_PRhypo1 = 12;
manip_PRhypo15 = 13;
manip_PRhypo2 = 14;
manip_PRhypo3 = 15;
manip_ghypo05 = 16;
manip_ghypo1 = 17;
manip_ghypo15 = 18;
manip_ghypo2 = 19;
manip_ghypo3 = 20;
manip_NShyper05 = 21;
manip_NShyper1 = 22;
manip_NShyper3 = 23;
manip_NShyper5 = 24;
manip_Bhyper05 = 25;
manip_Bhyper1 = 26;
manip_Bhyper3 = 27;
manip_Bhyper5 = 28;
manip_PRhyper05 = 29;
manip_PRhyper1 = 30;
manip_PRhyper3 = 31;
manip_PRhyper5 = 32;
manip_ghyper05 = 33;
manip_ghyper1 = 34;
manip_ghyper3 = 35;
manip_ghyper5 = 36;
manip_normal_rew0 = 37;
manip_Bhypo05_rew0 = 38;
manip_Bhypo1_rew0 = 39;
manip_Bhypo15_rew0 = 40;
manip_Bhypo2_rew0 = 41;
manip_Bhypo3_rew0 = 42;
manip_Bhyper05_rew0 = 43;
manip_Bhyper1_rew0 = 44;
manip_Bhyper3_rew0 = 45;
manip_Bhyper5_rew0 = 46;

% Set default path.
basepath_path = basepath_fulldata;
runcoll_path = runcoll_stats;
taskset_path = taskset_TOBS1c_TOBS1crev;
simphases_path = simphases_maint;
manip_path = manip_normal;
subj_num = 1;
run_num = 1;