%
% bsim_xx1.m
%
% Batch simulation place-holder function.
%
% Last modification: 12/13/07


% Set path stuff.
runcoll_path = runcoll_pilot;
taskset_path = taskset_TOBS1c_TOBS1crev;
simphases_path = simphases_maint;
% simphases_path = simphases_train;
% simphases_path = simphases_rev;
manip_path = manip_normal;   % not used
subj_num = 1;                % not used
run_num = 1;                 % not used
bsim_setdatapath;

% Set collected data file.
fname = strcat(path_pfx1,path_pfx2,path_pfx3,path_pfx4,'colldata.mat');

% Load the collected data file.
load(fname);

% manip_conds = [ manip_NShypo3 manip_NShypo2 manip_NShypo15 ...
%     manip_NShypo1 manip_NShypo05 manip_normal manip_NShyper05 ...
%     manip_NShyper1 manip_NShyper3 manip_NShyper5 ];
% manip_conds = [ manip_Bhypo3 manip_Bhypo2 manip_Bhypo15 ...
%     manip_Bhypo1 manip_Bhypo05 manip_normal manip_Bhyper05 ...
%     manip_Bhyper1 manip_Bhyper3 manip_Bhyper5 ];
% manip_conds = [ manip_PRhypo3 manip_PRhypo2 manip_PRhypo15 ...
%     manip_PRhypo1 manip_PRhypo05 manip_normal manip_PRhyper05 ...
%     manip_PRhyper1 manip_PRhyper3 manip_PRhyper5 ];
% manip_conds = [ manip_ghypo3 manip_ghypo2 manip_ghypo15 ...
%     manip_ghypo1 manip_ghypo05 manip_normal manip_ghyper05 ...
%     manip_ghyper1 manip_ghyper3 manip_ghyper5 ];
% if (manip_conds(1) == manip_NShypo3)
%     pathmanip_ind = 1;
% elseif (manip_conds(1) == manip_Bhypo3)
%     pathmanip_ind = 2;    
% elseif (manip_conds(1) == manip_PRhypo3)
%     pathmanip_ind = 3;        
% elseif (manip_conds(1) == manip_ghypo3)
%     pathmanip_ind = 4;  
% end;

% Separate plot view
figure;
subplot(2,2,1);
dat_means = zeros(1,num_conds);
dat_stds = zeros(1,num_conds);
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,1));
    dat_stds(xx) = std(mean_RTs(xx,:,1));
end;
errorbar(dat_means,dat_stds);
title('DA Effect on RT');
xlabel('DA Condition');
ylabel('RT (in ms)');
set(gca,'XTick',1:num_conds);
axis([0.5 (num_conds + 0.5) 600 2600]);
set(gca,'XTickLabel',{'ns3';'ns2';'ns15';'ns1';'ns05';'norm';'NS05'; ...
    'NS1';'NS3';'NS5'}); 
 
subplot(2,2,2);
dat_means = zeros(1,num_conds);
dat_stds = zeros(1,num_conds);
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,2));
    dat_stds(xx) = std(mean_RTs(xx,:,2));
end;
errorbar(dat_means,dat_stds);
title('DA Effect on RT');
xlabel('DA Condition');
ylabel('RT (in ms)');
set(gca,'XTick',1:num_conds);
axis([0.5 (num_conds + 0.5) 600 2600]);
set(gca,'XTickLabel',{'b3';'b2';'b15';'b1';'b05';'norm';'B05'; ...
    'B1';'B3';'B5'}); 

subplot(2,2,3);
dat_means = zeros(1,num_conds);
dat_stds = zeros(1,num_conds);
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,3));
    dat_stds(xx) = std(mean_RTs(xx,:,3));
end;
errorbar(dat_means,dat_stds);
title('DA Effect on RT');
xlabel('DA Condition');
ylabel('RT (in ms)');
set(gca,'XTick',1:num_conds);
axis([0.5 (num_conds + 0.5) 600 2600]);
set(gca,'XTickLabel',{'pr3';'pr2';'pr15';'pr1';'pr05';'norm';'PR05'; ...
    'PR1';'PR3';'PR5'});   
    
subplot(2,2,4);
dat_means = zeros(1,num_conds);
dat_stds = zeros(1,num_conds);
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,4));
    dat_stds(xx) = std(mean_RTs(xx,:,4));
end;
errorbar(dat_means,dat_stds);
title('DA Effect on RT');
xlabel('DA Condition');
ylabel('RT (in ms)');
set(gca,'XTick',1:num_conds);
axis([0.5 (num_conds + 0.5) 600 2600]);
set(gca,'XTickLabel',{'g3';'g2';'g15';'g1';'g05';'norm';'G05'; ...
    'G1';'G3';'G5'});

% Overlaid multicolor plot view.
figure;
dat_means = zeros(1,num_conds);
dat_stds = zeros(1,num_conds);
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,1));
    dat_stds(xx) = std(mean_RTs(xx,:,1));
end;
errorbar(dat_means,dat_stds,'r');
hold on;
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,2));
    dat_stds(xx) = std(mean_RTs(xx,:,2));
end;
errorbar(dat_means,dat_stds,'g');
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,3));
    dat_stds(xx) = std(mean_RTs(xx,:,3));
end;
errorbar(dat_means,dat_stds,'b');
for xx = 1:num_conds
    dat_means(xx) = mean(mean_RTs(xx,:,4));
    dat_stds(xx) = std(mean_RTs(xx,:,4));
end;
errorbar(dat_means,dat_stds,'k');
hold off;
title('DA Effect on RT');
xlabel('DA Condition');
ylabel('RT (in ms)');
set(gca,'XTick',1:num_conds);
axis([0.5 (num_conds + 0.5) 600 2600]);
set(gca,'XTickLabel',{'x3';'x2';'x15';'x1';'x05';'norm';'X05'; ...
    'X1';'X3';'X5'});
legend('Nod/Shake','Babble','Plan/Request','All');