%
% combo_taskset_simrun.m
%
% Run a simulation that rewards the camera organism for combo taskset.
%
% Last modification: 8/22/07


% Set the active task to 0 if we're just getting started.
if (last_event_type == event_null)
    active_task = 0;
end;

% If we are between tasks, pick a task randomly.
if (active_task == 0)
    curr_iter_time = (iter - 1) * iter_duration;
    max_duration = num_iters * iter_duration;
    if (curr_iter_time < max_duration - tone_stim_duration - delay_duration)
        r = rand;
        if (r < blue_select_thresh)
            active_task = 1;
            curr_event_type = event_c_noresp;
            r = rand;
            num_task_stims = 1 + floor(r * 5);
        else
            active_task = 2;
            curr_event_type = event_eflat_noresp;
            r = rand;
            num_task_stims = 1 + floor(r * 5);
        end;
    else
        delay_duration = max_duration - curr_iter_time;
        curr_event_type = event_delay;
    end;    
    
% Otherwise, if we have just played the tone, do a delay.
elseif ((last_event_type == event_c_noresp) || ...
    (last_event_type == event_eflat_noresp))
    curr_event_type = event_delay;
    
% Otherwise, if task 1 is active...
elseif (active_task == 1)
    if (last_event_type ~= event_delay)
        num_task_stims = num_task_stims - 1;
    end;
    blue_select_simrun;
    if (num_task_stims == 0)
        active_task = 0;
    end;
    
% Otherwise, if task 2 is active...    
elseif (active_task == 2)
    if (last_event_type ~= event_delay)
        num_task_stims = num_task_stims - 1;
    end;
    red_select_simrun;
    if (num_task_stims == 0)
        active_task = 0;
    end;   
end;