%
% disp_area_act.m
%
% Display the activation of the network area indexed by area_ind.
% Used during simulation run.
%
% Depends on: area_ind, S, Area_xy
%
% Last modification: 10/15/04

% Find the upper and lower indices for the units we want to look at.
lo_bound = 1;
for xx = 1:area_ind - 1
    lo_bound = lo_bound + Area_xy(xx,3);
end;
hi_bound = lo_bound + Area_xy(area_ind,3) - 1;

% Plot the unit activations scaled between 0 and 1.
activs = reshape(S(lo_bound:hi_bound),Area_xy(area_ind,2),Area_xy(area_ind,1));
imagesc(activs,[0 1.0]);
axis square;
%colorbar;