%
% fetch_area_activs.m
%
% Get the activations of the network area indexed by area_ind. 
% Used during a simulation run.
%
% Depends on: area_ind, S, Area_xy
%
% Last modification: 6/6/07

% Find the upper and lower indices for the units we want to look at.
lo_bound = 1;
for xx_faa = 1:area_ind - 1
    lo_bound = lo_bound + Area_xy(xx_faa,3);
end;
hi_bound = lo_bound + Area_xy(area_ind,3) - 1;

% Grab the activations we're interested in.
activs = S(lo_bound:hi_bound)';
activs = reshape(activs,Area_xy(area_ind,2),Area_xy(area_ind,1));