%
% fetch_area_unit_inds.m
%
% Get the unit indices of the network area indexed by area_ind.
%
% Depends on: area_ind, Area_xy
%
% Last modification: 6/6/07

% Find the upper and lower indices for the units we want to look at.
lo_bound = 1;
for xx_faui = 1:area_ind - 1
    lo_bound = lo_bound + Area_xy(xx_faui,3);
end;
hi_bound = lo_bound + Area_xy(area_ind,3) - 1;

% Grab the unit indices we're interested in and reshape into an
% appropriately-dimensioned matrix.
unit_inds = reshape(lo_bound:hi_bound,Area_xy(area_ind,2), ...
    Area_xy(area_ind,1));