%
% load2curr_simrun.m
%
% Load a saved model, writing it to the current model.
%
% Last modification: 3/24/08


% Clear all variables and close all windows.
% clear all;
% close all;

% Load simulation run parameters.
load sim_run_params;

% Set the path.
% runcoll_path = runcoll_stats;
runcoll_path = runcoll_exemplar;
% taskset_path = taskset_TOBS1c_TOBS1crev;
taskset_path = taskset_TOBS_TOBSrev;
simphases_path = simphases_train;
% simphases_path = simphases_maint;
% simphases_path = simphases_rev;
manip_path = manip_normal;
subj_num = 1;
run_num = 15;
bsim_setdatapath;

% Set the paths.
% setpaths_simrun;

% Prompt on whether to proceed.
prompt_str = strcat('About to load run ',num2str(run_num),' in\n', ...
    path_name,'\nProceed? (1=yes) ');
proceed = input(prompt_str);
if (proceed ~= 1)
    disp('aborted');
    return;
end;

% Set the current file names.
% phys_parm_fname = 'phys_parm_1.dat';
% model_parm_fname = 'model_1.dat';
sim_out_fname = 'sim_out1';   % don't need to tack on '.mat'
cogmodel_out_fname = 'cog_out1';   % don't need to tack on '.mat'
start_model_fname = 'modl_parm_1';   % don't need to tack on '.mat'
train_model_fname = 'modl_parm_tr';   % don't need to tack on '.mat'
prev_train_model_fname = 'prev_modl_parm_tr'; 
                              % don't need to tack on '.mat'
backup_model_fname = 'backup_modl_parm_tr';   
                              % don't need to tack on '.mat'                    
phys_fname = 'phys_parm_1';   % don't need to tack on '.mat' 
    
% Set the simrun file names
% simrun_phys_parm_fname = strcat(path_name,run_pfx,'phys_parm_8.23.07.dat');
% simrun_model_parm_fname = strcat(path_name,run_pfx,'model_8.23.07.dat');
simrun_sim_out_fname = strcat(path_name,run_pfx,'sim_out');
        % don't need to tack on '.mat'
simrun_cogmodel_out_fname = strcat(path_name,run_pfx,'cog_out');   
        % don't need to tack on '.mat'
simrun_start_model_fname = strcat(path_name,run_pfx,'modl_parm'); 
        % don't need to tack on '.mat'
simrun_train_model_fname = strcat(path_name,run_pfx,'modl_parm_tr');
        % don't need to tack on '.mat'
simrun_prev_train_model_fname = strcat(path_name,run_pfx,'prev_modl_parm_tr');
        % don't need to tack on '.mat'
simrun_backup_model_fname = strcat(path_name,run_pfx,'backup_modl_parm_tr');
        % don't need to tack on '.mat'        
simrun_phys_fname = strcat(path_name,run_pfx,'phys_parm');   
        % don't need to tack on '.mat'   

% Try to copy the files.
% sfname = simrun_phys_parm_fname;
% tfname = phys_parm_fname;
% cp_err = copyfile(sfname,tfname);
% if (cp_err == 0)
%     disp('The phys_parm_fname file doesn''t exist.');
% end;

% sfname = simrun_model_parm_fname;
% tfname = model_parm_fname;
% cp_err = copyfile(sfname,tfname);
% if (cp_err == 0)
%     disp('The model_parm_fname file doesn''t exist.');
% end;

sfname = strcat(simrun_sim_out_fname,'.mat');
tfname = strcat(sim_out_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The sim_out_fname file doesn''t exist.');
end;

sfname = strcat(simrun_cogmodel_out_fname,'.mat');
tfname = strcat(cogmodel_out_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The cogmodel_out_fname file doesn''t exist.');
end;

sfname = strcat(simrun_start_model_fname,'.mat');
tfname = strcat(start_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The start_model_fname file doesn''t exist.');
end;

sfname = strcat(simrun_train_model_fname,'.mat');
tfname = strcat(train_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The train_model_fname file doesn''t exist.');
end;

sfname = strcat(simrun_prev_train_model_fname,'.mat');
tfname = strcat(prev_train_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The prev_train_model_fname file doesn''t exist.');
end;

sfname = strcat(simrun_backup_model_fname,'.mat');
tfname = strcat(backup_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The backup_model_fname file doesn''t exist.');
end;

sfname = strcat(simrun_phys_fname,'.mat');
tfname = strcat(phys_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The phys_fname file doesn''t exist.');
end;  

% Initialize the simulator types.
init_PISHTAR_types;

% Load the simulation output data;
disp('Loading simulation output data...');
load(simrun_sim_out_fname);

% Reset the precalculation variable for show_trial.
precalc_fascins_done = 0;

% If we're running a cognitive (neural) model...
if (brain_type == brain_cog_model)
    % Load model parameters (connectivity and cell/channel-types).
    load(simrun_start_model_fname);

    % Load physiological parameters (cells and channels).
    load(simrun_phys_fname);
  
    % Load the neural output data;
    disp('Loading neural output data...');
    load(simrun_cogmodel_out_fname);
    
    % Get indices for different parts of the model.
    get_cog_model_indices;  
end;