%
% load_simrun.m
%
% Load an already-run simulation of the pan-tilt camera robot, brains and 
% all.
%
% Last modification: 10/17/07

% Set the paths.
% setpaths_simrun;

% Set the simrun file names
% simrun_phys_parm_fname = strcat(path_name,run_pfx,'phys_parm_8.23.07.dat');
% simrun_model_parm_fname = strcat(path_name,run_pfx,'model_8.23.07.dat');
simrun_sim_out_fname = strcat(path_name,run_pfx,'sim_out');
        % don't need to tack on '.mat'
simrun_cogmodel_out_fname = strcat(path_name,run_pfx,'cog_out');   
        % don't need to tack on '.mat'
simrun_start_model_fname = strcat(path_name,run_pfx,'modl_parm'); 
        % don't need to tack on '.mat'
simrun_train_model_fname = strcat(path_name,run_pfx,'modl_parm_tr');
        % don't need to tack on '.mat'
simrun_prev_train_model_fname = strcat(path_name,run_pfx,'prev_modl_parm_tr');
        % don't need to tack on '.mat'
simrun_backup_model_fname = strcat(path_name,run_pfx,'backup_modl_parm_tr');
        % don't need to tack on '.mat'        
simrun_phys_fname = strcat(path_name,run_pfx,'phys_parm');  
        % don't need to tack on '.mat'

% Initialize the simulator types.
init_PISHTAR_types;

% Load the simulation output data;
disp('Loading simulation output data...');
load(simrun_sim_out_fname);

% Reset the precalculation variable for show_trial.
precalc_fascins_done = 0;

% If we're running a cognitive (neural) model...
if (brain_type == brain_cog_model)
    % Load model parameters (connectivity and cell/channel-types).
    load(simrun_start_model_fname);

    % Load physiological parameters (cells and channels).
    load(simrun_phys_fname);
  
    % Load the neural output data;
    disp('Loading neural output data...');
    load(simrun_cogmodel_out_fname);
    
    % Get indices for different parts of the model.
    get_cog_model_indices;  
end;