%
% make_trial_movie.m
%
% Make an AVI movie of the simulation.
%
% Last modification: 5/6/08


% Clear all variables and close all windows.
% clear all;
% close all;

% Load the simulation data.
% load_pantilt_sim;

% Open a movie file.
% mov = avifile('fulltask_train_run15.avi');
% mov = avifile('fulltask_rev_run7.avi');
% mov = avifile('fulltask_train_run4_1to500.avi');
% mov = avifile('ft_train_run4_1to500_babblego.avi');
% mov = avifile('ft_train_run3_1to200.avi');
% mov = avifile('ft_train_run3_1to200_planreqwts.avi');
% mov = avifile('ft_train_run3_1to200_shakegowts.avi');
% mov = avifile('ft_rev_run1_1to500.avi');
mov = avifile('ft_rev_run1_1to500_planreqwts.avi');

% Create the figure window.
make_disp_fig;

% Set up the start and end iterations and interframe pause time.
start_iter = 1;
end_iter = num_iters;
interframe_pause = 0.01;
% interframe_pause = 1.0;  % for my (S L O W) lab desktop machine

% Grab script arguments if they exist.
if (~isempty(who('st_sargs')))
    nargs = size(st_sargs,2);
    if (nargs >= 3)
        start_iter = st_sargs(2);
        end_iter = st_sargs(3);
    end;
end;

% Display the simulation iterations.
iter = start_iter;
done = 0;
while (done == 0)
    disp_trial_step;
    F = getframe(fh);
    mov = addframe(mov,F);
    pause(interframe_pause); 
    iter = iter + 1;
    if (iter == end_iter + 1)
        done = 1;
    end;
end;

% Close the avi file.
mov = close(mov);