
    % Load the physical parameters and model data from the handles data.
    thresh = handles.thresh;
    gain = handles.gain;
    namp = handles.namp;
    outtimeconst = handles.outtimeconst;
    DA_out_mod = handles.DA_out_mod;
    hi_DA_thresh = handles.hi_DA_thresh;
    hi_DA_gain = handles.hi_DA_gain;
    VI = handles.VI;
    inhib = handles.inhib;
    MOD = handles.MOD;
    eligib_duration = handles.eligib_duration;
    eligib_pre_thresh = handles.eligib_pre_thresh;
    eligib_post_thresh = handles.eligib_post_thresh;
    DA_plastic_hi_thresh = handles.DA_plastic_hi_thresh;
    DA_plastic_lo_thresh = handles.DA_plastic_lo_thresh;
    DA_LTP_hi = handles.DA_LTP_hi;
    LTP_learnrate = handles.LTP_learnrate;
    LTD_learnrate = handles.LTD_learnrate;
    maxwt = handles.maxwt;    
    
    Model_name = handles.Model_name;
    Num_areas = handles.Num_areas;
    Num_conns = handles.Num_conns;
    Area_name = handles.Area_name;
    Area_num = handles.Area_num;
    Cell_type = handles.Cell_type;
    Area_xy = handles.Area_xy;
    Conn_name = handles.Conn_name;
    Conn_fromto = handles.Conn_fromto;
    Chan_type = handles.Chan_type;
    Conn_kind = handles.Conn_kind;
    Conn_xy = handles.Conn_xy;
    Conn_prob = handles.Conn_prob;
    Weig_mean = handles.Weig_mean;
    Weig_sigm = handles.Weig_sigm;
    Conn_scle = handles.Conn_scle;
    CA = handles.CA;
    CW = handles.CW;
    CR = handles.CR;
    CH = handles.CH;
    CT = handles.CT;
    NC = handles.NC;
    NU = handles.NU;
    unit_offset = handles.unit_offset;   
    
    % Load the simulation data from the handles data.
    output = handles.output;
    mdc = handles.mdc;
    modCW = handles.modCW;
    num_iters = handles.num_iters;     
    
    % Load the view parameters from the edit boxes.
    time_ind = str2num(get(handles.edit1,'String'));
    source_area_ind = str2num(get(handles.edit2,'String'));
    target_area_ind = str2num(get(handles.edit3,'String'));
    fasc_ind = str2num(get(handles.edit4,'String'));
    x_ind = str2num(get(handles.edit5,'String'));
    y_ind = str2num(get(handles.edit6,'String'));
    if (get(handles.popupmenu1,'Value') == 1)
        fanin = 1;
    else
        fanin = 0;
    end;
    
    % Display the activations.
    S = output(:,time_ind)';
    axes(handles.source_area);
    colormap(gray);
    area_ind = source_area_ind;
    disp_area_act;
    xstr = strcat(Area_name(area_ind,:), ' Activation');
    xlabel(xstr);
    axes(handles.target_area);
    colormap(gray);
    area_ind = target_area_ind;
    disp_area_act;
    xstr = strcat(Area_name(area_ind,:), ' Activation');
    xlabel(xstr);   
    
    % Display weights.
    CW(mdc) = modCW(:,time_ind)';
    axes(handles.weights);
    disp_cell_wts;
    xstr = strcat(Conn_name(fasc_ind,:), ' Connections');
    xlabel(xstr);