function varargout = net_disp_tool(varargin)
% NET_DISP_TOOL Application M-file for net_disp_tool.fig
%    FIG = NET_DISP_TOOL launch net_disp_tool GUI.
%    NET_DISP_TOOL('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 04-Oct-2006 19:35:54

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

    % Read all the GUI elements and display the appropriate info.
    ndt_sub1;
       
    % Initialize the area display slider.
    set(handles.slider1,'Max',Num_areas);
    set(handles.slider1,'SliderStep',[1/(Num_areas-1) 1/(Num_areas-1)]);
    
    % Initialize the fascicle slider.
    set(handles.slider2,'Max',Num_conns);
    set(handles.slider2,'SliderStep',[1/(Num_conns-1) 1/(Num_conns-1)]);
    
    % Initialize the fascicle unit X slider.
    set(handles.slider3,'Max',Num_conns);
    set(handles.slider3,'SliderStep',[(1/Num_conns) (1/Num_conns)]);
    
    % Initialize the fascicle unit Y slider.
    set(handles.slider4,'Max',Num_conns);
    set(handles.slider4,'SliderStep',[(1/Num_conns) (1/Num_conns)]);
    
    % Initialize the simulation time unit slider.
    set(handles.slider5,'Max',num_iters);
    set(handles.slider5,'SliderStep',[1/(num_iters-1) 1/(num_iters-1)]);
    
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = edit1_Callback(h, eventdata, handles, varargin)

% Read all the GUI elements and display the appropriate info.
ndt_sub1;

% Set the area display slider appropriately.
set(handles.slider1,'Value',str2num(get(h,'String')));


% --------------------------------------------------------------------
function varargout = edit2_Callback(h, eventdata, handles, varargin)

% Read all the GUI elements and display the appropriate info.
ndt_sub1;

% Set the slider appropriately.
set(handles.slider2,'Value',str2num(get(h,'String')));

% Initialize the X index slider.
num_x_units = Area_xy(Conn_fromto(fasc_ind,2),1);
set(handles.slider3,'Max',num_x_units);
set(handles.slider3,'SliderStep',[1/(num_x_units-1) 1/(num_x_units-1)]);

% Initialize the Y index slider.
num_y_units = Area_xy(Conn_fromto(fasc_ind,2),2);   
set(handles.slider4,'Max',num_y_units);
set(handles.slider4,'SliderStep',[1/(num_y_units-1) 1/(num_y_units-1)]);

% --------------------------------------------------------------------
function varargout = edit3_Callback(h, eventdata, handles, varargin)

% Read all the GUI elements and display the appropriate info.
ndt_sub1;

% Set the slider appropriately.
set(handles.slider3,'Value',str2num(get(h,'String')));

% --------------------------------------------------------------------
function varargout = edit4_Callback(h, eventdata, handles, varargin)

% Read all the GUI elements and display the appropriate info.
ndt_sub1;

% Set the slider appropriately.
set(handles.slider4,'Value',str2num(get(h,'String')));


% --------------------------------------------------------------------
function varargout = slider1_Callback(h, eventdata, handles, varargin)

% Set the area display edit box to the right value.
set(handles.edit1,'String',num2str(get(h,'Value')));

% Read all the GUI elements and display the appropriate info.
ndt_sub1;


% --------------------------------------------------------------------
function varargout = slider2_Callback(h, eventdata, handles, varargin)

% Set the corresponding unit box to the right value.
set(handles.edit2,'String',num2str(get(h,'Value')));

% Read all the GUI elements and display the appropriate info.
ndt_sub1;

% Initialize the X index slider.
num_x_units = Area_xy(Conn_fromto(fasc_ind,2),1);
set(handles.slider3,'Max',num_x_units);
set(handles.slider3,'SliderStep',[1/(num_x_units-1) 1/(num_x_units-1)]);

% Initialize the Y index slider.
num_y_units = Area_xy(Conn_fromto(fasc_ind,2),2);   
set(handles.slider4,'Max',num_y_units);
set(handles.slider4,'SliderStep',[1/(num_y_units-1) 1/(num_y_units-1)]);

% --------------------------------------------------------------------
function varargout = slider3_Callback(h, eventdata, handles, varargin)

% Set the corresponding unit box to the right value.
set(handles.edit3,'String',num2str(get(h,'Value')));

% Read all the GUI elements and display the appropriate info.
ndt_sub1;


% --------------------------------------------------------------------
function varargout = slider4_Callback(h, eventdata, handles, varargin)

% Set the corresponding unit box to the right value.
set(handles.edit4,'String',num2str(get(h,'Value')));

% Read all the GUI elements and display the appropriate info.
ndt_sub1;



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double

% Read all the GUI elements and display the appropriate info.
ndt_sub1;

% Set the simulation time index slider appropriately.
set(handles.slider5,'Value',str2num(get(hObject,'String')));


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on slider movement.
function slider5_Callback(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Set the simulation time index edit box to the right value.
set(handles.edit5,'String',num2str(get(hObject,'Value')));

% Read all the GUI elements and display the appropriate info.
ndt_sub1;


% --- Executes during object creation, after setting all properties.
function slider5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


