%
% plot_activsB.m
%
% This script shows plots of either individual units in the model or plots
% of summed activity.  Mixtures of these are allowed, also.
%
% Last modification: 5/20/07


% Set up user-selected initial variables.
plot_title = 'Main Model Activity (C Tone Reward Test)';
plot_labels = ...          % 15 plots
    str2mat('default', ...
    'default', ...
    'default', ...
    'default', ...
    'default', ...    
    'default', ...   
    'default', ...       
    'default', ...
    'default', ... 
    'default', ...     
    'default', ...       
    'default', ...
    'default', ...  
    'default', ...      
    'default');

% Full plot
min_iter = 1;
max_iter = num_iters;

% Each row is a plot = [ custom? min_y max_y min_y_tick max_y_tick ]
% y_axis_layout = ...
%     [ 1  -1  11   0  10; ...
%       1  -1  11   0  10; ...
%       0   0   0   0   0 ];
y_axis_layout = ...    % 15 plots
    [ 0  -1  11   0  10; ...
      0  -1  11   0  10; ...
      0  -1  11   0  10; ...
      0  -1  11   0  10; ...  
      0  -1  11   0  10; ...        
      0  -1  11   0  10; ...  
      0  -1  11   0  10; ...  
      0  -1  11   0  10; ...
      0  -1  11   0  10; ... 
      0  -1  11   0  10; ...       
      0  -1  11   0  10; ...  
      0  -1  11   0  10; ...  
      0  -1  11   0  10; ...
      0  -1  11   0  10; ...      
      0  -1  11   0  10 ];
  
% Set up the figure window.
l_fig_pos = 0.01;
b_fig_pos = 0.05;
fig_w = 0.9;
fig_h = 0.85;
fh = figure(1);
set(fh,'Units','normalized');
set(fh,'Position',[l_fig_pos b_fig_pos fig_w fig_h]);
colormap(gray);

% Lay out the set of plots with a matrix.
% Each row is a plot = [ areaID# aggregate? unitX unitY ]
% disp_plot_map = ...
%     [ 16  1  2  3; ...
%       20  1  4  4; ...
%       23  0  1  1 ]; 
disp_plot_map = [ ...
      3  0  1  1; ...
     27  0  1  1; ...    
     12  0  1  1; ...       
      4  0  1  1; ...
      5  0  1  1; ...      
     14  0  1  1; ...
     15  0  1  1; ...     
     17  0  1  1  ...
     ];   
 
% Lines...
%       1  0  1  1; ...  % Test Tonic Hi Value Unit
%       2  0  1  1; ...  % Colors In Units (1 x 4)
%       3  0  1  1; ...  % Tones In Units (1 x 12)
%       4  0  1  1; ...  % Reward In Unit
%       5  0  1  1; ...  % Punisher In Unit
%       6  0  1  1; ...  % Track Exec Unit
%       7  0  1  1; ...  % Nod Exec Unit
%       8  0  1  1; ...  % Shake Exec Unit
%       9  0  1  1; ...  % Tonic DA Afferent Input Unit 
%      10  0  1  1; ...  % Novelty Configuration Excitatory units (unused)
%      11  0  1  1; ...  % Novelty Configuration Inhibitory units (unused)
%      12  0  1  1; ...  % Novelty Excitatory Unit
%      13  0  1  1; ...  % Novelty Inhibitory Unit (unused)
%      14  0  1  1; ...  % Reward Cue Excitatory Unit
%      15  0  1  1; ...  % Reward Cue Inhibitory Unit
%      16  0  1  1; ...  % Reward Prediction Units (1 x 40)
%      17  0  1  1; ...  % DA Signal Unit
%      18  0  1  1; ...  % Frustration Unit
%      19  0  1  1; ...  % Babble Request Unit  
%      20  0  1  1; ...  % Babble Go Unit 
%      21  0  1  1; ...  % Babble NoGo Unit 
%      22  0  1  1; ...  % Babble Init Unit  
%      23  0  1  1; ...  % Babble Exec Unit
%      24  0  1  1; ...  % Babble Excitatory Units (8 x 8)
%      25  0  1  1; ...  % Babble Inhibitory Units (8 x 8)
%      26  0  1  1; ...  % Color Working Memory Units (1 x 4)
%      27  0  1  1; ...  % Tones Working Memory Units (1 x 12)
%      28  0  1  1; ...  % Plan Excitatory Units (8 x 8)
%      29  0  1  1; ...  % Plan Inhibitory Units (8 x 8)
%      30  0  1  1; ...  % Plan Layer Regulatory Unit
%      31  0  1  1; ...  % Nod Request Excitatory Unit
%      32  0  1  1; ...  % Nod Request Inhibitory Unit
%      33  0  1  1; ...  % Nod Go Unit
%      34  0  1  1; ...  % Nod NoGo Unit
%      35  0  1  1; ...  % Nod Init Unit
%      36  0  1  1; ...  % Shake Request Excitatory Unit
%      37  0  1  1; ...  % Shake Request Inhibitory Unit
%      38  0  1  1; ...  % Shake Go Unit
%      39  0  1  1; ...  % Shake NoGo Unit
%      40  0  1  1; ...  % Shake Init Unit
%      41  0  1  1; ...  % Nod/Shake Conflict Unit

num_plots = size(disp_plot_map,1);
subplot_inds = zeros(num_plots,3);
for ii = 1:num_plots
    subplot_inds(ii,1) = num_plots;
    subplot_inds(ii,2) = 1;
    subplot_inds(ii,3) = ii;
end;

% Tabulate each of the plots.
the_plots = zeros(num_plots,num_iters);
for ii = 1:num_plots
    area_ind = disp_plot_map(ii,1);
    unit_x = disp_plot_map(ii,3);
    unit_y = disp_plot_map(ii,4);
    for jj = 1:num_iters
        time_ind = jj;
        fetchps_area_activs_iter;        
        if (disp_plot_map(ii,2) == 1)  % aggregate plot
            the_plots(ii,jj) = sum(sum(activs));
        else % unit plot
            the_plots(ii,jj) = activs(unit_y,unit_x);
        end;
    end;
end;

% Draw each of the plots.
for ii = 1:num_plots
    subplot(subplot_inds(ii,1), subplot_inds(ii,2), subplot_inds(ii,3));
    area(the_plots(ii,:));
    if (disp_plot_map(ii,2) == 1)  % aggregate plot
        if (y_axis_layout(ii,1) == 0)
            min_y_axis = 0;
            max_y_axis = 64; 
            min_y_tick = 0;
            max_y_tick = 60;
        else
            min_y_axis = y_axis_layout(ii,2);
            max_y_axis = y_axis_layout(ii,3); 
            min_y_tick = y_axis_layout(ii,4);
            max_y_tick = y_axis_layout(ii,5);           
        end;
        ylab_shift = (min_y_axis + max_y_axis) / 2;
        axis([min_iter max_iter min_y_axis max_y_axis]); 
        xlab_shift = (max_iter - min_iter) / 60;
        if (strcmp(plot_labels(ii,:), 'default'))       
            ystr = strcat(Area_name(disp_plot_map(ii,1),:), ' sum');
        else
            ystr = plot_labels(ii,:);
        end;
    else % unit plot
        if (y_axis_layout(ii,1) == 0)
            min_y_axis = -0.1;
            max_y_axis = 1.1; 
            min_y_tick = 0;
            max_y_tick = 1;
        else
            min_y_axis = y_axis_layout(ii,2);
            max_y_axis = y_axis_layout(ii,3); 
            min_y_tick = y_axis_layout(ii,4);
            max_y_tick = y_axis_layout(ii,5);           
        end;        
        ylab_shift = (min_y_axis + max_y_axis) / 2;
        axis([min_iter max_iter min_y_axis max_y_axis]);         
        xlab_shift = (max_iter - min_iter) / 60;
        if (strcmp(plot_labels(ii,:), 'default'))
            ystr = strcat(Area_name(disp_plot_map(ii,1),:),' (', ...
                num2str(disp_plot_map(ii,3)),',', ...
                num2str(disp_plot_map(ii,4)),')');
        else
            ystr = plot_labels(ii,:);
        end;

    end;
    text(min_iter-xlab_shift,ylab_shift,ystr,'HorizontalAlignment','right');
    set(gca,'YTick',[min_y_tick max_y_tick]);
    set(gca,'YTickLabel',[min_y_tick max_y_tick],'FontSize',8);
end;

% Show the title in the first subplot.
subplot(num_plots,1,1);
title(plot_title);

% Null out the X tick labels for all but the last subplot.
for ii = 1:(num_plots - 1);
    subplot(num_plots,1,ii);
    set(gca,'XTickLabel',[]);
end;

% Show the iterations in the last subplot.
subplot(num_plots,1,num_plots);
xlabel('Iterations (Increments of 100 ms)');