%
% precalc_fascins.m
%
% Precalculate fascicle net inputs.  Called by make_disp_fig.m.
%
% Last modification: 8/8/07


% Find indices mapping each connection to the corresponding index 
% to mdc (0 if no such connection exists).
Cmdc_ind = zeros(1,size(CW,2));
for xx = 1:size(CW,2)
    the_ind = find(mdc == xx);
    if (isempty(the_ind))
        Cmd_ind(xx) = 0;
    else
        Cmdc_ind(xx) = the_ind;
    end;
end;        

disp('Calculating Nod Init->Nod NoGo values...');
fasc_ind = NodInittoNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
nod_init_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
nod_init_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        nod_init_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
nod_init_nogo_fascins_uinds = unit_inds;    
nod_init_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(nod_init_nogo_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            nod_init_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (nod_init_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    nod_init_nogo_fascins_data(:,:,tt) = fascins;
end;         

disp('Calculating Dice->Nod NoGo Netin values...');
fasc_ind = TNoisetoNNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
dice_nod_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
dice_nod_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;
        dice_nod_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
dice_nod_nogo_fascins_uinds = unit_inds;    
dice_nod_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(dice_nod_nogo_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz                     
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            dice_nod_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (dice_nod_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;                    
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    dice_nod_nogo_fascins_data(:,:,tt) = fascins;
end;  

disp('Calculating Color WM->Nod NoGo Netin values...');
fasc_ind = Color_WMtoNNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_nod_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_nod_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_nod_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_nod_nogo_fascins_uinds = unit_inds;    
color_wm_nod_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_nod_nogo_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_nod_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_nod_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_nod_nogo_fascins_data(:,:,tt) = fascins;
end;   

disp('Calculating Tones WM->Nod NoGo Netin values...');
fasc_ind = Tones_WMtoNNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_nod_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_nod_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_nod_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_nod_nogo_fascins_uinds = unit_inds;    
tones_wm_nod_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_nod_nogo_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_nod_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_nod_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_nod_nogo_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Shake Init->NoGo Netin values...');
fasc_ind = ShakeInittoNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
shake_init_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
shake_init_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        shake_init_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
shake_init_nogo_fascins_uinds = unit_inds;    
shake_init_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(shake_init_nogo_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            shake_init_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (shake_init_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    shake_init_nogo_fascins_data(:,:,tt) = fascins;
end;         

disp('Calculating Dice->Shake NoGo Netin values...');
fasc_ind = TNoisetoSNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
dice_shake_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
dice_shake_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;
        dice_shake_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
dice_shake_nogo_fascins_uinds = unit_inds;    
dice_shake_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(dice_shake_nogo_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz                     
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            dice_shake_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (dice_shake_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;                    
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    dice_shake_nogo_fascins_data(:,:,tt) = fascins;
end;  

disp('Calculating Color WM->Shake NoGo Netin values...');
fasc_ind = Color_WMtoSNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_shake_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_shake_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_shake_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_shake_nogo_fascins_uinds = unit_inds;    
color_wm_shake_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_shake_nogo_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_shake_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_shake_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_shake_nogo_fascins_data(:,:,tt) = fascins;
end;   

disp('Calculating Tones WM->Shake NoGo Netin values...');
fasc_ind = Tones_WMtoSNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_shake_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_shake_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_shake_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_shake_nogo_fascins_uinds = unit_inds;    
tones_wm_shake_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_shake_nogo_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_shake_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_shake_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_shake_nogo_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Nod Request->Go Netin values...');
fasc_ind = NodReqtoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
nod_req_go_fascins_mod = MOD(Chan_type(fasc_ind));
nod_req_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        nod_req_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
nod_req_go_fascins_uinds = unit_inds;    
nod_req_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(nod_req_go_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            nod_req_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (nod_req_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    nod_req_go_fascins_data(:,:,tt) = fascins;
end;         

disp('Calculating Dice->Nod Go Netin values...');
fasc_ind = TNoisetoNGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
dice_nod_go_fascins_mod = MOD(Chan_type(fasc_ind));
dice_nod_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;
        dice_nod_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
dice_nod_go_fascins_uinds = unit_inds;    
dice_nod_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(dice_nod_go_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz                     
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            dice_nod_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (dice_nod_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;                    
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    dice_nod_go_fascins_data(:,:,tt) = fascins;
end;  

disp('Calculating Color WM->Nod Go Netin values...');
fasc_ind = Color_WMtoNGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_nod_go_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_nod_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_nod_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_nod_go_fascins_uinds = unit_inds;    
color_wm_nod_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_nod_go_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_nod_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_nod_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_nod_go_fascins_data(:,:,tt) = fascins;
end;   

disp('Calculating Tones WM->Nod Go Netin values...');
fasc_ind = Tones_WMtoNGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_nod_go_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_nod_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_nod_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_nod_go_fascins_uinds = unit_inds;    
tones_wm_nod_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_nod_go_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_nod_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_nod_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_nod_go_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Shake Request->Go Netin values...');
fasc_ind = ShakeReqtoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
shake_req_go_fascins_mod = MOD(Chan_type(fasc_ind));
shake_req_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        shake_req_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
shake_req_go_fascins_uinds = unit_inds;    
shake_req_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(shake_req_go_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            shake_req_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (shake_req_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    shake_req_go_fascins_data(:,:,tt) = fascins;
end;         

disp('Calculating Dice->Shake Go Netin values...');
fasc_ind = TNoisetoSGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
dice_shake_go_fascins_mod = MOD(Chan_type(fasc_ind));
dice_shake_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;
        dice_shake_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
dice_shake_go_fascins_uinds = unit_inds;    
dice_shake_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(dice_shake_go_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz                     
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            dice_shake_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (dice_shake_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;                    
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    dice_shake_go_fascins_data(:,:,tt) = fascins;
end;  

disp('Calculating Color WM->Shake Go Netin values...');
fasc_ind = Color_WMtoSGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_shake_go_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_shake_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_shake_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_shake_go_fascins_uinds = unit_inds;    
color_wm_shake_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_shake_go_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_shake_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_shake_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_shake_go_fascins_data(:,:,tt) = fascins;
end;   

disp('Calculating Tones WM->Shake Go Netin values...');
fasc_ind = Tones_WMtoSGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_shake_go_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_shake_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_shake_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_shake_go_fascins_uinds = unit_inds;    
tones_wm_shake_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_shake_go_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_shake_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_shake_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_shake_go_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Babble Init->Babble NoGo values...');
fasc_ind = BabbleInittoNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
babble_init_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
babble_init_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        babble_init_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
babble_init_nogo_fascins_uinds = unit_inds;    
babble_init_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(babble_init_nogo_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            babble_init_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (babble_init_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    babble_init_nogo_fascins_data(:,:,tt) = fascins;
end;         

disp('Calculating Dice->Babble NoGo Netin values...');
fasc_ind = TNoisetoBNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
dice_babble_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
dice_babble_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;
        dice_babble_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
dice_babble_nogo_fascins_uinds = unit_inds;    
dice_babble_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(dice_babble_nogo_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz                     
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            dice_babble_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (dice_babble_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;                    
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    dice_babble_nogo_fascins_data(:,:,tt) = fascins;
end;  

disp('Calculating Color WM->Babble NoGo Netin values...');
fasc_ind = Color_WMtoBNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_babble_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_babble_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_babble_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_babble_nogo_fascins_uinds = unit_inds;    
color_wm_babble_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_babble_nogo_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_babble_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_babble_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_babble_nogo_fascins_data(:,:,tt) = fascins;
end;   

disp('Calculating Tones WM->Babble NoGo Netin values...');
fasc_ind = Tones_WMtoBNoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_babble_nogo_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_babble_nogo_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_babble_nogo_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_babble_nogo_fascins_uinds = unit_inds;    
tones_wm_babble_nogo_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_babble_nogo_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_babble_nogo_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_babble_nogo_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_babble_nogo_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Babble Request->Go Netin values...');
fasc_ind = BabbleReqtoGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
babble_req_go_fascins_mod = MOD(Chan_type(fasc_ind));
babble_req_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        babble_req_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
babble_req_go_fascins_uinds = unit_inds;    
babble_req_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(babble_req_go_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            babble_req_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (babble_req_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    babble_req_go_fascins_data(:,:,tt) = fascins;
end;         

disp('Calculating Dice->Babble Go Netin values...');
fasc_ind = TNoisetoBGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
dice_babble_go_fascins_mod = MOD(Chan_type(fasc_ind));
dice_babble_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;
        dice_babble_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
dice_babble_go_fascins_uinds = unit_inds;    
dice_babble_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(dice_babble_go_fascins_uinds); 
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz                     
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            dice_babble_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (dice_babble_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;                    
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    dice_babble_go_fascins_data(:,:,tt) = fascins;
end;  

disp('Calculating Color WM->Babble Go Netin values...');
fasc_ind = Color_WMtoBGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_babble_go_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_babble_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_babble_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_babble_go_fascins_uinds = unit_inds;    
color_wm_babble_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_babble_go_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_babble_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_babble_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_babble_go_fascins_data(:,:,tt) = fascins;
end;   

disp('Calculating Tones WM->Babble Go Netin values...');
fasc_ind = Tones_WMtoBGo_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_babble_go_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_babble_go_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_babble_go_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_babble_go_fascins_uinds = unit_inds;    
tones_wm_babble_go_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_babble_go_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_babble_go_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_babble_go_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_babble_go_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating VisPres->Plan Netin values...');
fasc_ind = VisStimtoPlan_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
vispres_plan_fascins_mod = MOD(Chan_type(fasc_ind));
vispres_plan_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        vispres_plan_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
vispres_plan_fascins_uinds = unit_inds;    
vispres_plan_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(vispres_plan_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            vispres_plan_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (vispres_plan_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    vispres_plan_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Color WM->Plan Netin values...');
fasc_ind = Color_WMtoPlan_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
color_wm_plan_fascins_mod = MOD(Chan_type(fasc_ind));
color_wm_plan_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        color_wm_plan_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
color_wm_plan_fascins_uinds = unit_inds;    
color_wm_plan_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(color_wm_plan_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            color_wm_plan_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (color_wm_plan_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    color_wm_plan_fascins_data(:,:,tt) = fascins;
end;

disp('Calculating Tones WM->Plan Netin values...');
fasc_ind = Tones_WMtoPlan_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
tones_wm_plan_fascins_mod = MOD(Chan_type(fasc_ind));
tones_wm_plan_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        tones_wm_plan_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
tones_wm_plan_fascins_uinds = unit_inds;    
tones_wm_plan_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(tones_wm_plan_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            tones_wm_plan_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (tones_wm_plan_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    tones_wm_plan_fascins_data(:,:,tt) = fascins;
end;

disp('Calculating Babble->Plan Netin values...');
fasc_ind = BabbletoPlan_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
babble_plan_fascins_mod = MOD(Chan_type(fasc_ind));
babble_plan_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        babble_plan_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
babble_plan_fascins_uinds = unit_inds;    
babble_plan_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(babble_plan_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            babble_plan_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (babble_plan_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    babble_plan_fascins_data(:,:,tt) = fascins;
end;

disp('Calculating Bias->Plan Netin values...');
fasc_ind = PlanBias_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
bias_plan_fascins_mod = MOD(Chan_type(fasc_ind));
bias_plan_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        bias_plan_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
bias_plan_fascins_uinds = unit_inds;    
bias_plan_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(bias_plan_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            bias_plan_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (bias_plan_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    bias_plan_fascins_data(:,:,tt) = fascins;
end;

disp('Calculating Plan->Nod Request Netin values...');
fasc_ind = PlantoNodReqE_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
plan_nod_req_fascins_mod = MOD(Chan_type(fasc_ind));
plan_nod_req_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        plan_nod_req_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
plan_nod_req_fascins_uinds = unit_inds;    
plan_nod_req_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(plan_nod_req_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            plan_nod_req_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (plan_nod_req_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    plan_nod_req_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Babble->Nod Request Netin values...');
fasc_ind = BabbletoNodReqE_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
babble_nod_req_fascins_mod = MOD(Chan_type(fasc_ind));
babble_nod_req_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        babble_nod_req_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
babble_nod_req_fascins_uinds = unit_inds;    
babble_nod_req_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(babble_nod_req_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            babble_nod_req_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (babble_nod_req_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    babble_nod_req_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Bias->Nod Request Netin values...');
fasc_ind = NodReqBias_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
bias_nod_req_fascins_mod = MOD(Chan_type(fasc_ind));
bias_nod_req_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        bias_nod_req_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
bias_nod_req_fascins_uinds = unit_inds;    
bias_nod_req_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(bias_nod_req_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            bias_nod_req_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (bias_nod_req_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    bias_nod_req_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Plan->Shake Request Netin values...');
fasc_ind = PlantoShakeReqE_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
plan_shake_req_fascins_mod = MOD(Chan_type(fasc_ind));
plan_shake_req_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        plan_shake_req_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
plan_shake_req_fascins_uinds = unit_inds;    
plan_shake_req_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(plan_shake_req_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            plan_shake_req_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (plan_shake_req_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    plan_shake_req_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Babble->Shake Request Netin values...');
fasc_ind = BabbletoShakeReqE_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
babble_shake_req_fascins_mod = MOD(Chan_type(fasc_ind));
babble_shake_req_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        babble_shake_req_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
babble_shake_req_fascins_uinds = unit_inds;    
babble_shake_req_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(babble_shake_req_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            babble_shake_req_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (babble_shake_req_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    babble_shake_req_fascins_data(:,:,tt) = fascins;
end; 

disp('Calculating Bias->Shake Request Netin values...');
fasc_ind = ShakeReqBias_ind;           
in_x_sz = Area_xy(Conn_fromto(fasc_ind,1),1);
in_y_sz = Area_xy(Conn_fromto(fasc_ind,1),2);
out_x_sz = Area_xy(Conn_fromto(fasc_ind,2),1);
out_y_sz = Area_xy(Conn_fromto(fasc_ind,2),2);
bias_shake_req_fascins_mod = MOD(Chan_type(fasc_ind));
bias_shake_req_fascins_winds = zeros(out_y_sz,out_x_sz,in_y_sz, ...
    in_x_sz);               
for xx = 1:out_x_sz
    for yy = 1:out_y_sz
        fanin = 1;
        x_ind = xx;
        y_ind = yy;
        fetch_cell_wt_inds;    
        bias_shake_req_fascins_winds(yy,xx,:,:) = wt_inds;         
    end;
end;   
area_ind = Conn_fromto(fasc_ind,1);
fetch_area_unit_inds;
bias_shake_req_fascins_uinds = unit_inds;    
bias_shake_req_fascins_data = zeros(out_y_sz,out_x_sz,num_iters);
for tt = 1:num_iters
    if (tt == 1)
        fascins = zeros(out_y_sz,out_x_sz);
    else
        S = output(:,tt-1)';
        modCWcurr = modCW(:,tt)';
        activs = S(bias_shake_req_fascins_uinds);
        if (size(activs,1) == 1)
            activs = activs';
        end;
        for xx = 1:out_x_sz
            for yy = 1:out_y_sz  
                wts = zeros(in_y_sz,in_x_sz);
                winds = zeros(in_y_sz,in_x_sz);
                for xx1 = 1:in_x_sz
                    for yy1 = 1:in_y_sz
                        winds(yy1,xx1) = ...
                            bias_shake_req_fascins_winds(yy,xx,yy1,xx1);
                    end;
                end;
                [r c] = find(winds);
                for zz = 1:size(r,1)
                    if (bias_shake_req_fascins_mod == 1)                         
                        wts(r(zz),c(zz)) = modCWcurr(Cmdc_ind( ...
                            winds(r(zz),c(zz))));                        
                    else 
                        wts(r(zz),c(zz)) = CW(winds(r(zz),c(zz)));                    
                    end; 
                end;   
                fascins(yy,xx) = sum(sum(activs .* wts));
            end;
        end;
    end;          
    bias_shake_req_fascins_data(:,:,tt) = fascins;
end; 

precalc_fascins_done = 1;