%
% save_simrun.m
%
% Save the current model run for future access.
%
% Last modification: 10/18/07


% Clear all variables and close all windows.
% clear all;
% close all;

% Load simulation run parameters.
% load sim_run_params;

% Set the paths.
% setpaths_simrun;

% Set the simrun file names
% simrun_phys_parm_fname = strcat(path_name,run_pfx,'phys_parm_8.23.07.dat');
% simrun_model_parm_fname = strcat(path_name,run_pfx,'model_8.23.07.dat');
simrun_sim_out_fname = strcat(path_name,run_pfx,'sim_out');
        % don't need to tack on '.mat'
simrun_cogmodel_out_fname = strcat(path_name,run_pfx,'cog_out');   
        % don't need to tack on '.mat'
simrun_start_model_fname = strcat(path_name,run_pfx,'modl_parm'); 
        % don't need to tack on '.mat'
simrun_train_model_fname = strcat(path_name,run_pfx,'modl_parm_tr');
        % don't need to tack on '.mat'
simrun_prev_train_model_fname = strcat(path_name,run_pfx,'prev_modl_parm_tr');
        % don't need to tack on '.mat'
simrun_backup_model_fname = strcat(path_name,run_pfx,'backup_modl_parm_tr');
        % don't need to tack on '.mat'        
simrun_phys_fname = strcat(path_name,run_pfx,'phys_parm');   
        % don't need to tack on '.mat'   

% Try to copy the files.
% sfname = phys_parm_fname;
% tfname = simrun_phys_parm_fname;
% cp_err = copyfile(sfname,tfname);
% if (cp_err == 0)
%     disp('The phys_parm_fname file doesn''t exist.');
% end;

% sfname = model_parm_fname;
% tfname = simrun_model_parm_fname;
% cp_err = copyfile(sfname,tfname);
% if (cp_err == 0)
%     disp('The model_parm_fname file doesn''t exist.');
% end;

sfname = strcat(sim_out_fname,'.mat');
tfname = strcat(simrun_sim_out_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The sim_out_fname file doesn''t exist.');
end;

sfname = strcat(cogmodel_out_fname,'.mat');
tfname = strcat(simrun_cogmodel_out_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The cogmodel_out_fname file doesn''t exist.');
end;

sfname = strcat(start_model_fname,'.mat');
tfname = strcat(simrun_start_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The start_model_fname file doesn''t exist.');
end;

sfname = strcat(train_model_fname,'.mat');
tfname = strcat(simrun_train_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The train_model_fname file doesn''t exist.');
end;

sfname = strcat(prev_train_model_fname,'.mat');
tfname = strcat(simrun_prev_train_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The prev_train_model_fname file doesn''t exist.');
end;

sfname = strcat(backup_model_fname,'.mat');
tfname = strcat(simrun_backup_model_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The backup_model_fname file doesn''t exist.');
end;

sfname = strcat(phys_fname,'.mat');
tfname = strcat(simrun_phys_fname,'.mat');
cp_err = copyfile(sfname,tfname);
if (cp_err == 0)
    disp('The phys_fname file doesn''t exist.');
end;  