%
% show_trial.m
%
% Show the complete trial from out1.
%
% Last modification: 6/7/07


% Clear all variables and close all windows.
% clear all;
% close all;

% Load the simulation data.
% load_pantilt_sim;

% Create the figure window.
make_disp_fig;

% Set up the start and end iterations and interframe pause time.
start_iter = 1;
end_iter = num_iters;
interframe_pause = 0.001;
get_key_input = 1;
keywaittime = 0.5;
bigiterjump = 10;
% start_iter = 700;
% end_iter = 800;

% Grab script arguments if they exist.
if (~isempty(who('st_sargs')))
    nargs = size(st_sargs,2);
    if (nargs >= 3)
        start_iter = st_sargs(2);
        end_iter = st_sargs(3);
    end;
end;

% Display the simulation iterations.
iter = start_iter;
paused = 0;
done = 0;
while (done == 0)
    disp_trial_step;
    pause(interframe_pause); 
    if (paused == 0)
        iter = iter + 1;
    end;    
    if (get_key_input == 1)
        ch = getkeywait(keywaittime); 
        if (ch == ch_esc)  % ESC quits the simulation
            break;
        end;
        switch ch
            % q = full speed for rest of iterations
            case ch_q
                paused = 0;
                get_key_input = 0;            
            % d = pause/unpause simulation
            case ch_d
                if (paused == 0)
                    paused = 1;
                else
                    paused = 0;
                end;
            % s = back one iteration
            case ch_s
                iter = iter - 1;
                if (iter < start_iter)
                    iter = start_iter;
                end;
            % f = forward one iteration
            case ch_f
                iter = iter + 1;
                if (iter > end_iter)
                    iter = end_iter;
                end; 
            % w = jump to first iteration
            case ch_w
                iter = start_iter;
            % r = jump to last iteration
            case ch_r
                iter = end_iter;
            % a = back a number of iterations
            case ch_a
                iter = iter - bigiterjump;
                if (iter < start_iter)
                    iter = start_iter;
                end;
            % g = forward a number of iterations
            case ch_g
                iter = iter + bigiterjump;
                if (iter > end_iter)
                    iter = end_iter;
                end;                 
        end;
    end;  
    if (iter == end_iter + 1)
        done = 1;
    end;
end;